#include <ppl.h>
#include <string>
#include <iostream>

using namespace Concurrency;
using namespace std;

// ޹    Ͽ ȯ
template <typename T>
T twice(const T& t) 
{
    return t + t;
}

int wmain()
{
    int n = 54;
    double d = 5.6;
    wstring s = L"Hello";

    // 3 Ÿ   twice Լ ķ 
    structured_task_group tg;
    auto t1 = make_task([&n] { n = twice(n); });
    auto t2 = make_task([&d] { d = twice(d); });
    auto t3 = make_task([&s] { s = twice(s); });

    tg.run(t1);
    tg.run(t2);
    tg.run_and_wait(t3);

    //   
    wcout << n << L' ' << d << L' ' << s << endl;
}