#include <ppl.h>
#include <iostream>

using namespace Concurrency;
using namespace std;

int main()
{
    combinable<int> counts;
    parallel_invoke(
        [&counts] {
            for(int i = 0; i < 100000000; ++i)
                ++counts.local();
        },
        [&counts] {
            for(int i = 0; i < 100000000; ++i)
                ++counts.local();
        }
    );
    long count = counts.combine(plus<int>());

    wcout << L"count: " << count << endl;
    return 0;
}