#include <ppl.h>
#include <iostream>
#include <sstream>

using namespace Concurrency;
using namespace std;

// ۾ Լ
bool work(int index)
{
    if (index == 100)
        return false;

    return true;
}

int wmain()
{
    // θ ½ũ ׷ tg1 
    structured_task_group tg1;

    // ø ½ũ ׷ ϴ ½ũ t1 
    auto t1 = make_task([&tg1] {

        // ø ½ũ ׷ tg2 
        structured_task_group tg2;

        // ڽ ½ũ t4 
        auto t4 = make_task([&] {
            for (int i = 0; i < 1000; ++i)
            {
                // ۾ Լ ϰ   false  
                // ܸ ߻ ½ũ ׷ 
                bool succeeded = work(i);
                if (!succeeded)
                {
                    wcout << L"Canceling tg1..." << endl;
                    throw exception("The task failed");
                }
            }
        });

        // ڽ ½ũ t5 
        auto t5 = make_task([] {
            for (int i = 0; i < 1000000; ++i)
            {
                // 100 ݺ    û 
                if ((i % 100) == 0)
                {
                    if (is_current_task_group_canceling())
                    {
                        //  û Ǹ ̴ ۾ 
                        wcout << L"The t5 was canceled." << endl;
                        break;
                    }
                }

                // TODO: ۾ 
            }
        });

        // ڽ ½ũ ϰ  
        tg2.run(t4);
        tg2.run(t5);
        tg2.wait();
    });

    // ڽ ½ũ t2 
    auto t2 = make_task([] {
        for (int i = 0; i < 1000000; ++i)
        {
            // 100 ݺ    û 
            if ((i % 100) == 0)
            {
                if (is_current_task_group_canceling())
                {
                    //  û Ǹ ̴ ۾ 
                    wcout << L"The t2 was canceled." << endl;
                    break;
                }
            }

            // TODO: ۾ 
        }
    });

    // ڽ ½ũ t3 
    auto t3 = make_task([] {
        for (int i = 0; i < 1000000; ++i)
        {
            // 100 ݺ    û 
            if ((i % 100) == 0)
            {
                if (is_current_task_group_canceling())
                {
                    //  û Ǹ ̴ ۾ 
                    wcout << L"The t3 was canceled." << endl;
                    break;
                }
            }

            // TODO: ۾ 
        }
    });

    // ڽ ½ũ ϰ  
    tg1.run(t1);
    tg1.run(t2);
    tg1.run(t3);

    try
    {
        // θ ½ũ ׷쿡   ó
        tg1.wait();
    }
    catch (const exception& e)
    {
        wcout << e.what() << endl;
    }
}
